#ifdef _SIZE_ROM_128K_               // 18F8722
#define SIZE_ROM                     131072         //       (0x20000)
//  0x40 = 64
#define START_PROGRAM_ADDR           SIZE_ROM - 64 // 131008 (0x1FFC0)  Start_Program()
#define START_BOOTLOAD_ADRR          130804         //       (0x1FEF4)  Start_Bootload()
#define START_MAIN_BOOTLOAD_ADRR     130424        //        (0x1FD78)  main()
#pragma orgall                       130400        //        (0x1FD60)  ROM-672
#define _ROM_block_0_    block[0] = 0xBC;
#define _ROM_block_1_    block[1] = 0xEF;
#define _ROM_block_2_    block[2] = 0xFE;
#define _ROM_block_3_    block[3] = 0xF0;
#endif

#ifdef _SIZE_ROM_96K_                // 18F4685
#define SIZE_ROM                     98304         //        (0x18000)
//  0x40 = 64
#define START_PROGRAM_ADDR           SIZE_ROM - 64 // 98240  (0x17FC0)  Start_Program()
#define START_BOOTLOAD_ADRR          97996         //        (0x17ECC)  Start_Bootload()
#define START_MAIN_BOOTLOAD_ADRR     97656         //        (0x17D78)  main()
#pragma orgall                       97632         //        (0x17D60)  ROM-672
#define _ROM_block_0_    block[0] = 0xBC;
#define _ROM_block_1_    block[1] = 0xEF;
#define _ROM_block_2_    block[2] = 0xBE;
#define _ROM_block_3_    block[3] = 0xF0;
#endif

#ifdef _SIZE_ROM_64K_                // 18F2620 - 18F46K20
#define SIZE_ROM                     65536         //        (0x10000)
//  0x40 = 64
#define START_PROGRAM_ADDR           SIZE_ROM - 64 // 65472  (0xFFC0)  Start_Program()
#define START_BOOTLOAD_ADRR          65186         //        (0xFEA2)  Start_Bootload()
#define START_MAIN_BOOTLOAD_ADRR     64888         //        (0xFD78)  main()
#pragma orgall                       64864         //        (0xFD60)  ROM-672
#define _ROM_block_0_    block[0] = 0xBC;
#define _ROM_block_1_    block[1] = 0xEF;
#define _ROM_block_2_    block[2] = 0x7E;
#define _ROM_block_3_    block[3] = 0xF0;
#endif

#ifdef _SIZE_ROM_48K_                // 18F2585 - 18F45K22
#define SIZE_ROM                     49152         //        (0xC000)
//  0x40 = 64
#define START_PROGRAM_ADDR           SIZE_ROM - 64 // 49088  (0xBFC0)  Start_Program()
#define START_BOOTLOAD_ADRR          48884         //        (0xBEF4)  Start_Bootload()
#define START_MAIN_BOOTLOAD_ADRR     48498         //        (0xBD72)  main()
#pragma orgall                       48480         //        (0xBD60)  ROM-672
#define _ROM_block_0_    block[0] = 0xB9;
#define _ROM_block_1_    block[1] = 0xEF;
#define _ROM_block_2_    block[2] = 0x5E;
#define _ROM_block_3_    block[3] = 0xF0;
#endif

#ifdef _SIZE_ROM_32K_                // 18F4520
#define SIZE_ROM                     32768         //        (0x8000)
//  0x40 = 64
#define START_PROGRAM_ADDR           SIZE_ROM - 64 // 32704  (0x7FC0)  Start_Program()
#define START_BOOTLOAD_ADRR          32504         //        (0x7EF8)  Start_Bootload()
#define START_MAIN_BOOTLOAD_ADRR     32112         //        (0x7D70)  main()
#pragma orgall                       32096         //        (0x7D60)  ROM-672
#define _ROM_block_0_    block[0] = 0xB8;
#define _ROM_block_1_    block[1] = 0xEF;
#define _ROM_block_2_    block[2] = 0x3E;
#define _ROM_block_3_    block[3] = 0xF0;
#endif

#ifdef _SIZE_ROM_24K_                // 18F2455
#define SIZE_ROM                     24576         //        (0x6000)
//  0x40 = 64
#define START_PROGRAM_ADDR           SIZE_ROM - 64 // 24512  (0x5FC0)  Start_Program()
#define START_BOOTLOAD_ADRR          24308         //        (0x5EF4)  Start_Bootload()
#define START_MAIN_BOOTLOAD_ADRR     23928         //        (0x5D78)  main()
#pragma orgall                       23904         //        (0x5D60)  ROM-672
#define _ROM_block_0_    block[0] = 0xBC;
#define _ROM_block_1_    block[1] = 0xEF;
#define _ROM_block_2_    block[2] = 0x2E;
#define _ROM_block_3_    block[3] = 0xF0;
#endif

#ifdef _SIZE_ROM_16K_                // 18F242
#define SIZE_ROM                     16384         //        (0x4000)
//  0x40 = 64
#define START_PROGRAM_ADDR           SIZE_ROM - 64 // 16320  (0x3FC0)  Start_Program()
#define START_BOOTLOAD_ADRR          16116         //        (0x3EF4)  Start_Bootload()
#define START_MAIN_BOOTLOAD_ADRR     15732         //        (0x3D74)  main()
#pragma orgall                       15712         //        (0x3D60)  ROM-672
#define _ROM_block_0_    block[0] = 0xBA;
#define _ROM_block_1_    block[1] = 0xEF;
#define _ROM_block_2_    block[2] = 0x1E;
#define _ROM_block_3_    block[3] = 0xF0;
#endif

#ifdef _SIZE_ROM_12K_                // 18F2439
#define SIZE_ROM                     12288         //        (0x3000)
//  0x40 = 64
#define START_PROGRAM_ADDR           SIZE_ROM - 64 // 12224  (0x2FC0)  Start_Program()
#define START_BOOTLOAD_ADRR          12020         //        (0x2EF4)  Start_Bootload()
#define START_MAIN_BOOTLOAD_ADRR     11636         //        (0x2D74)  main()
#pragma orgall                       11616         //        (0x2D60)  ROM-672
#define _ROM_block_0_    block[0] = 0xBA;
#define _ROM_block_1_    block[1] = 0xEF;
#define _ROM_block_2_    block[2] = 0x16;
#define _ROM_block_3_    block[3] = 0xF0;
#endif

#ifdef _SIZE_ROM_8K_                 // 18F4320
#define SIZE_ROM                     8192          //        (0x2000)
//  0x40 = 64
#define START_PROGRAM_ADDR           SIZE_ROM - 64 // 8128   (0x1FC0)  Start_Program()
#define START_BOOTLOAD_ADRR          7924          //        (0x1EF4)  Start_Bootload()
#define START_MAIN_BOOTLOAD_ADRR     7528          //        (0x1D68)  main()
#pragma orgall                       7520          //        (0x1D60)  ROM-672
#define _ROM_block_0_    block[0] = 0xB4;
#define _ROM_block_1_    block[1] = 0xEF;
#define _ROM_block_2_    block[2] = 0x0E;
#define _ROM_block_3_    block[3] = 0xF0;
#endif

#ifdef _SIZE_ROM_4K_                 // 18F4220
#define SIZE_ROM                     4096          //        (0x1000)
//  0x40 = 64
#define START_PROGRAM_ADDR           SIZE_ROM - 64 // 4032   (0xFC0)  Start_Program()
#define START_BOOTLOAD_ADRR          3832          //        (0xEF8)  Start_Bootload()
#define START_MAIN_BOOTLOAD_ADRR     3440          //        (0xD70)  main()
#pragma orgall                       3424          //        (0xD60)  ROM-672
#define _ROM_block_0_    block[0] = 0xB8;
#define _ROM_block_1_    block[1] = 0xEF;
#define _ROM_block_2_    block[2] = 0x06;
#define _ROM_block_3_    block[3] = 0xF0;
#endif

void Start_Bootload();
void Start_Program();

unsigned short UART_Write_Loop(char send, char receive);

/*
 * constants :
 *  _FLASH_WRITE_LATCH - flash write latch size
 *  _FLASH_ERASE       - flash erase block size
 * are related to mcu flash memory write and erase block sizes
 * and as such are defined in appropriate flash library file.
 * Be aware that these constants are MCU dependent.
 * Compiler will link them from appropriate flash library,
 * so the user does not have to take care of them.
 *
 */
static char block[64];

//-------------- Empty function, this is where the start address of 'real'
//               program will be placed (by Write_Begin()). That is why
//               this function must have at least 4 bytes of ROM available
//               after its org address.
// _Start_Program 2 Bytes
void Start_Program() org START_PROGRAM_ADDR {
}

unsigned short UART_Write_Loop(char send, char receive)
{
  unsigned short rslt = 0;

  while(1)
  {
    Delay_5ms();
    UART1_Write(send);
    Delay_5ms();

    rslt++;

  if(rslt == 255u)  return 0;
  if(UART1_Read() == receive) return 1;
  }
}

//-------------- This void will recover the bootlocation 0x0000, 0x0001 and
//               0x0002 to point to the bootloaer's main. It will also move
//               the reset vector of the program that is uploaded to a new
//               location, in this case START_MAIN_BOOTLOAD_ADRR

void Write_Begin()
{
  FLASH_Erase_Write_64(START_PROGRAM_ADDR, block);
  //--- goto main START_MAIN_BOOTLOAD_ADRR
  _ROM_block_0_
  _ROM_block_1_
  _ROM_block_2_
  _ROM_block_3_
}

//-------------- Starts with bootload
void Start_Bootload() org START_BOOTLOAD_ADRR {
  unsigned short i = 0, xx, yy;
  long j = 0;

  while(1)
  {
    if(i == 64u)
    {
      //--- If 32 words (64 bytes) recieved then write to flash
      if(!j) Write_Begin();

      //if(j<START_MAIN_BOOTLOAD_ADRR)
          FLASH_Erase_Write_64(j, block);
      i = 0;
      j += 0x40;
    }
    //--- Ask for yy
    UART1_Write('y');
    while(!UART1_Data_Ready()) ;
    //--- Read yy
    yy = UART1_Read();
    //--- Ask for xx
    UART1_Write('x');
    while(!UART1_Data_Ready()) ;
    //--- Read xx
    xx = UART1_Read();
    //--- Save xxyy in block[i]
    block[i++] = yy;
    block[i++] = xx;
  }
}